<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !name.isValid}">
      <label for="name">Nom de la catégorie</label>
      <input
          class="form-control"
          type="text"
          id="name"
          v-model.trim="name.val"
          @blur="clearValidity('name')"
      />
      <p v-if="!name.isValid">Le nom de la catégorie ne doit pas etre vide.</p>
    </div>
    <base-button>Modifier</base-button>

  </form>
</template>

<script>

export default {
  props:{
    oldName : String,
    category : Object
  },
  data() {
    return {
      name: {
        val: this.category.name,
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.name.val === '') {
        this.name.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();

      if (!this.formIsValid) {
        return;
      }

      const formData = {
        name : this.name.val,
        id : this.category.id
      }
      try{
        this.$emit('edit-data', formData);
      }catch (e) {
        console.log(e)
      }
    },
  },
};
</script>

<style scoped>
</style>